<?php

/** ensure this file is being included by a parent file */
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

global $_PLUGINS;

$_PLUGINS->registerFunction( 'onBeforeUsersListBuildQuery', 'buildExQuery', 'bbUserList' );
$_PLUGINS->registerFunction( 'onBeforeUsersListQuery', 'fixExQuery', 'bbUserList' );
$_PLUGINS->registerFunction( 'onAfterUsersCountQuery', 'fixExQuery2', 'bbUserList' );
$_PLUGINS->registerFunction( 'onBeforeUserProfileDisplay', 'extraUser', 'bbUserList' );


class bbUserList extends cbTabHandler
{

    // Add extra filter user with articles condition
    public function buildExQuery(&$tablesSQL, &$joinsSQL, &$tablesWhereSQL)
    {
        $joinsSQL[] = 'JOIN #__content c ON c.created_by = u.id';
    }


    public function fixExQuery(&$queryFrom)
    {
        $queryFrom = str_replace("FROM", ", COUNT(c.id) AS cb_totalarticle FROM", $queryFrom);
        $queryFrom = str_replace('`hits`', 'ue.`hits`', $queryFrom);

        preg_match("#\(`cb_totalarticle`[^)].+\)#i", $queryFrom, $sqlPattern);

        $queryFrom = preg_replace("#AND \(`cb_totalarticle`[^)].+\)#i", "", $queryFrom); // Remove

        $extraSql = "";

        if ( !empty($sqlPattern[0]) )
        {
            $extraSql = "HAVING {$sqlPattern[0]}";
        }
        $queryFrom .= " GROUP BY u.id {$extraSql}";
    }


    public function fixExQuery2(&$total, &$queryFrom)
    {
        global $_CB_database;

        $sql    = "SELECT u.id " . $queryFrom;

        $_CB_database->setQuery($sql);

        $result = $_CB_database->query();

        $total  = $_CB_database->getNumRows($result);
    }


    public function extraUser(&$user)
    {
        global $_CB_database;

        $sql = "SELECT COUNT(*) FROM #__content WHERE created_by = ".$user->id;

        $_CB_database->setQuery($sql);

        $user->cb_totalarticle = $_CB_database->loadResult();
    }
}